/* OpenCP Module Player
   copyright (c) '94-'05 Niklas Beisert <nbeisert@physik.tu-muenchen.de>
 *
 * GMDPlay note dots routines
 *
 * revision history: (please note changes here)
 *  -nb980510   Niklas Beisert <nbeisert@physik.tu-muenchen.de>
 *    -first release
 */

#include "config.h"
#include <stdio.h> /* FILE is defined here */
#include "types.h"
#include "cpiface/cpiface.h"
#include "dev/mcp.h"
#include "gmdplay.h"
#include "gmdpdots.h"

/*extern unsigned short plNLChan;*/

int __attribute__ ((visibility ("internal"))) gmdGetDots(struct notedotsdata *d, int max)
{
	int pos=0;
	int i;
	for (i=0; i<plNLChan; i++)
	{
		struct chaninfo ci;
		int vl,vr;

		if (!mpGetChanStatus(i))
			continue;

		mpGetChanInfo(i, &ci);

		mpGetRealVolume(i, &vl, &vr);
		if (!vl&&!vr&&!ci.vol)
			continue;

		if (pos>=max)
			break;
		d[pos].voll=vl;
		d[pos].volr=vr;
		d[pos].chan=i;
		d[pos].note=mpGetRealNote(i);
		d[pos].col=32+(ci.ins&15);/* sustain */
		pos++;
	}
	return pos;
}
